

\ProvidesPackage{wikidata.sty}

\RequirePackage{silence}
%\WarningsOff*
\RequirePackage{fontspec}
\setmainfont{Alegreya}
\RequirePackage{setspace}
\RequirePackage[dvipsnames,svgnames]{xcolor}
\RequirePackage{academicons}
\RequirePackage{ccicons}
\RequirePackage{etoolbox}
\RequirePackage{xkeyval}
\RequirePackage{babel}
\RequirePackage{hvfloat}

\RequirePackage{datetime2}
\RequirePackage[style=ieee,backend=biber]{biblatex}
%\RequirePackage{svg} %required for svg images

\RequirePackage[automark]{scrlayer-scrpage}


\RequirePackage{microtype}
\RequirePackage{xurl}
\RequirePackage{bookmark}
\RequirePackage[
    paper=a4paper,
	top=30mm,
	right=17mm,
    bottom=30mm,
	left=30mm,
	footskip=17mm,
	marginparsep=3mm,
	marginparwidth=40mm,
	reversemarginpar=true
]{geometry}
\RequirePackage{graphicx}
    \graphicspath{{figures/}}

\RequirePackage{booktabs}
\RequirePackage{tabularray}
\NewTblrTheme{MainTheme}{
  % \SetTblrTemplate{lastfood}{default}{\\\bottomrule}
  \SetTblrStyle{head}{%
    bg=tableHeadingsBG,
    fg=tableHeadingsFont
  }
  \SetTblrInner{%
	row{1-Z}={font=\footnotesize\sffamily},
    row{odd} = {bg=tableRows},
    row{1}={%
      bg=tableHeadingsBG,
      fg=tableHeadingsFont,
      font=\bfseries,
      halign={c},
      valign={m},
    %  cmd={\hypersetup{linkcolor=white}} % not working
    },
    %row{Z}={bg=white,fg=black,font=\bfseries},
    width = \linewidth,
    hline{1,Z} = {2pt,fg=tableOuterLines}, % toprule and bottomrule
    hline{2} = {1pt,fg=tableOuterLines}, % midrule
    }
}



\definecolor{orcid}         {RGB} {166, 206, 57}

\colorlet{primarycolor}     {DarkViolet}
\colorlet{secundarycolor}   {Plum}

\colorlet{graycolor}        {DarkGray}
\colorlet{highlightcolor1}  {IndianRed}
\colorlet{highlightcolor2}  {MediumSeaGreen}
\colorlet{highlightcolor3}  {Teal}
\colorlet{highlightcolor4}  {SteelBlue}

\colorlet{filecolor}        {highlightcolor1}
\colorlet{linkcolor}        {highlightcolor2}
\colorlet{citecolor}        {highlightcolor3}
\colorlet{urlcolor}         {highlightcolor4}
\definecolor{rwthBlue}{RGB}{0,84,159}
\colorlet{primarycolor}         {rwthBlue}

\colorlet{backgroundcolor}  {graycolor!10}
% background for the table headings
\colorlet{tableHeadingsBG}{graycolor}
% depending on the color above we need to modify the font color, too.
\colorlet{tableHeadingsFont}{primarycolor}
% the very first and the very last line color
\colorlet{tableOuterLines}{highlightcolor1}
% alternating row colors.
\colorlet{tableRows}{backgroundcolor}

\DeclareRobustCommand\orcidlink[1]{\texorpdfstring{%
    \href{https://orcid.org/#1}{\textcolor{orcid}{\aiOrcid}}}{}}

\RequirePackage{lineno}
     \renewcommand{\linenumberfont}{\ttfamily\small\color{primarycolor}}


\setstretch{1.25}

\RequirePackage{tcolorbox}
\tcbuselibrary{
  listings,
  minted,
  skins,
  breakable
}


\providecommand{\sparql}[1]{\texttt{#1}}
\providecommand{\wiki}[1]{\texttt{#1}}

\newtcolorbox{whitebox}{colback=white,arc=0pt,outer arc=0pt,colframe=white}
\newtcolorbox{graybox}{
  colback=gray!10,
  arc=3pt,
%  outer arc=0pt,
  colframe=gray!10,
  coltitle=white,
  colbacktitle=black,
  coltext=black,
  fontupper={\sffamily\footnotesize},
  title={\bfseries\abstractname}
}
\RequirePackage[ragged,norule]{footmisc}
\renewcommand{\footnotemargin}{-.75em}
%\renewcommand*{\thefootnote}{\arabic{footnote}}
% \renewcommand*\@makefntext[1]%
% 	{\noindent{\@thefnmark}. #1}

\RequirePackage[
    %format=hang,
    justification=raggedright,
    singlelinecheck=off,
    labelfont=bf,
    font={normalfont,sf}]{caption}

\newcommand\setfield[2]{\csdef{@#1#2}}
\newcommand\getfield[2]{\ifcsvoid{@#1#2}{}{\csuse{@#1#2}}}
\newcommand\printfield[3]{%
    \ifcsvoid{@#1#2}{}{\csuse{@#1#2}\unskip#3}%
}

\newcommand\keywords[1]%
	{\setfield{keywords}{}{#1}}
\newcommand\datesubmitted[1]%
	{\setfield{datesubmitted}{}{#1}}
\newcommand\datereceived[1]%
	{\setfield{datereceived}{}{#1}}
\newcommand\dateaccepted[1]%
	{\setfield{dateaccepted}{}{#1}}
	\let\date\relax
\newcommand\datepublished[1]%
	{\setfield{datepublished}{}{#1}%
	\setfield{date}{}{#1}}
\newcommand\doi[1]%
	{\setfield{doi}{}{\href{https://doi.org/#1}{doi.org/#1}}}
\newcommand\shorttitle[1]%
	{\setfield{shorttitle}{}{#1}}
\newcommand\articletype[1]%
	{\setfield{articletype}{}{#1}}
	\setfield{articletype}{}{Research Article}
\newcommand\reviewer[1]%
	{\setfield{reviewer}{}{#1}}
\newcommand\dataavailability[1]%
	{\setfield{dataavailability}{}{#1}}
\newcommand\softwareavailability[1]%
	{\setfield{softwareavailability}{}{#1}}
\newcommand\licenses[1]%
	{\setfield{licenses}{}{#1}}

\newcounter{authors}
\newcounter{affiliations}
\newcounter{counter}


\define@key{author}{orcid}{\csdef{author@orcid}{#1}}
\define@key{author}{surname}{\csdef{author@surname}{#1}}
\define@key{author}{given-names}{\csdef{author@givennames}{#1}}
\define@key{author}{email}{\csdef{author@email}{#1}}
\define@key{author}{affiliation}{\csdef{author@affiliation}{#1}}
\define@key{author}{equal-contrib}{\csdef{author@equalcontrib}{#1}}
\define@key{author}{cor-id}{\csdef{author@corid}{#1}}
\define@key{author}{contribution}{\csdef{author@contribution}{#1}}
\presetkeys{author}{ % Set default values
	email=,
	affiliation=,
	contribution=,
	}{}

\define@key{affiliation}{id}{\csdef{aff@id}{#1}}
\define@key{affiliation}{group}{\csdef{aff@group}{#1}}
\define@key{affiliation}{department}{\csdef{aff@department}{#1}}
\define@key{affiliation}{organization}{\csdef{aff@organization}{#1}}
\define@key{affiliation}{isni}{\csdef{aff@isni}{#1}}
\define@key{affiliation}{ringgold}{\csdef{aff@ringgold}{#1}}
\define@key{affiliation}{ror}{\csdef{aff@ror}{#1}}
\define@key{affiliation}{pid}{\csdef{aff@pid}{#1}}
\define@key{affiliation}{street-address}{\csdef{aff@streetaddress}{#1}}
\define@key{affiliation}{city}{\csdef{aff@city}{#1}}
\define@key{affiliation}{country}{\csdef{aff@county}{#1}}
\define@key{affiliation}{country-code}{\csdef{aff@countrycode}{#1}}
\presetkeys{affiliation}{ % Set default values
	organization=,
	street-address=,
	country=,
	country-code=,
	}{}

\renewcommand\author[1]{%
	\begingroup
	\global\stepcounter{authors}%
	\setkeys{author}{#1}%
	\global\csedef{@orcid\theauthors}{\expandafter\author@orcid}%
	\global\csedef{@surname\theauthors}{\expandafter\author@surname}%
	\global\csedef{@givennames\theauthors}{\expandafter\author@givennames}%
	\global\csedef{@email\theauthors}{\expandafter\author@email}%
	\global\csedef{@affiliation\theauthors}{\expandafter\author@affiliation}%
	\global\csedef{@contribution\theauthors}{\expandafter\author@contribution}%
	\endgroup
}

\newcommand\affiliation[1]{%
	\begingroup
	\setkeys{affiliation}{#1}
	\global\csedef{@department\aff@id}{\expandafter\aff@department}%
	\global\csedef{@organization\aff@id}{\expandafter\aff@organization}%
	\global\csedef{@streetaddress\aff@id}{\expandafter\aff@streetaddress}%
	\global\csedef{@city\aff@id}{\expandafter\aff@city}%
	\endgroup
}

\newcommand\printauthor[1]{%
	\printfield{givennames}{#1}{} \printfield{surname}{#1}{}
	\ifcsvoid{@orcid#1}{\unskip}{\unskip\,\orcidlink{\csuse{@orcid#1}}}
	\ifcsvoid{@affiliation#1}
	{}
	{%
		\ifcsvoid{@affilmarker\csuse{@affiliation#1}}
		{%
			\stepcounter{affiliations}%
			\csedef{@affilmarker\csuse{@affiliation#1}}{\theaffiliations}%
			\csedef{@affilnum\theaffiliations}{\csuse{@affiliation#1}}%
		}{}%
	}%
	\unskip\,\textsuperscript{\csuse{@affilmarker\csuse{@affiliation#1}}}%
}

\newcommand\printaffiliation[1]{%
	\printfield{affilmarker}{#1}{\space}%
	\printfield{department}{#1}{, }%
	\printfield{organization}{#1}{, }%
	\printfield{streetaddress}{#1}{, }%
	\printfield{city}{#1}{.}
}

\newcommand\printcontribution[1]{%
	\ifcsvoid{@contribution#1}
	{}
	{\textbf{\printfield{givennames}{#1}{} \printfield{surname}{#1}{}:} \printfield{contribution}{#1}{}}
}

\newcommand\printauthors{
	\setcounter{counter}{0}
	\@whilenum\value{counter}<\value{authors}\do
	{\stepcounter{counter}\printauthor{\thecounter}\par}
}

\newcommand\printaffiliations{
	\setcounter{counter}{0}
	\@whilenum\value{counter}<\value{affiliations}\do
	{\stepcounter{counter}\printaffiliation{\csuse{@affilnum\thecounter}}\par}
}

\newcommand\printcontributions{
    \section{Roles and contributions}
	\setcounter{counter}{0}
	\@whilenum\value{counter}<\value{authors}\do
	{\stepcounter{counter}\printcontribution{\thecounter}\par}
}

\newcommand\printacknowledgements{
    \IfFileExists{acknowledgements.tex}
        {\section{Acknowledgements}
         \input{acknowledgements.tex}}
        {}
}



\def\@maketitle{%
	\newpage \null%
	\begin{whitebox}
		\begin{flushleft}%
			\normalsize\sffamily%
			{\normalsize\MakeUppercase{\@articletype}\par}
			{\Large\bfseries \@title \par}%
			{\normalsize\bfseries\@subtitle\par}%
			{\vskip 1.5em%
				\normalsize\printauthors
				\vskip 1.5em%
					{\footnotesize\printaffiliations}
				\vskip 1em%
			}
		\end{flushleft}%
	\end{whitebox}
}

\renewenvironment{abstract}
{\begin{graybox}}
{\end{graybox}}


\RequirePackage{hyperref}
\hypersetup{
	colorlinks=true,
	filecolor=filecolor,
	linkcolor=linkcolor,
	urlcolor=urlcolor,
	citecolor=citecolor,
}
\RequirePackage{csquotes} %shifted to avoid warning

\IfFileExists{./metadata/authors.tex}
    {\input{./metadata/authors.tex}}
    {}


\AtEndDocument{
%    \printacknowledgements
%    \printcontributions
%    \printbibliography
}
\RequirePackage{cleveref}


\newtcblisting[
	auto counter,
	number within=section,
	crefname={Abfrage}{Abfragen}
	]{mySPAQRL}[2][]{%
  skin=enhanced,
    bottomsep at break=14.8pt,
    topsep at break=14.8pt,
%	floatplacement=!ht,
%	float,
  listing engine=minted,
minted style=colorful,
minted language=SPARQL,
minted options={
  fontsize=\small,
  breaklines,
  autogobble,
  linenos,
  numbersep=1em},
colback=graycolor!5,
colframe=black,
listing only,
left=0mm,
right=0mm,
enhanced,
%     overlay={\begin{tcbclipinterior}\fill[graycolor] (frame.south west)		 rectangle ([xshift=5mm]frame.north west);\end{tcbclipinterior}},
title={Abfrage~\thetcbcounter: #2},
#1
	  %,breakable
   }
